#ifndef SCHED_TIME_H
#define SCHED_TIME_H

void reset_sched_time(void);

extern unsigned long time_zero;
extern unsigned long time_zero_wrapped;

static inline unsigned long current_sched_time(void)
{
	unsigned long now = micros();

	// avoid overflow on wrap-around
	if (now > time_zero)
		return now - time_zero;
	else
		// equal to ULONG_MAX - (time_zero - now) + 1;
		return time_zero_wrapped + now;
}

void sched_time_shift_by(unsigned long delta);

static inline bool time_after(unsigned long a, unsigned long b)
{
	return ((long) b) - ((long) a) < 0;
}


#endif
