#!/usr/bin/env python3

import sys
import os
import math

def lcm(a, b):
    return (a * b) // math.gcd(a, b)

def compute_hyperperiod(fname):
    task_lines = open(fname).readlines()[2:]
    periods = [int(line.strip().split(" ")[-1]) for line in task_lines]
    hyperperiod = 1
    for p in periods:
        hyperperiod = lcm(hyperperiod, p)
    return hyperperiod

if __name__ == '__main__':
    for path in sys.argv[1:]:
        hp = compute_hyperperiod(path)
        print(path, '->', hp)
        f = open(path.replace('.txt', 'hy.txt'), 'w')
        print(hp, file=f)
        f.close()
