#!/bin/bash

DIR=$1
S=$2


if [ -z "$DIR" ]
then
    cat <<USAGE
Usage: $0 <EXPERIMENT> [<SCHEDULER>]

<EXPERIMENT> is the path to a folder with a task set. 

<SCHEDULER> must be either "TABLE" or "OE".

USAGE
    exit 1
fi

if [ -z "$S" ]
then
    S="TABLE"
fi

SCRIPTS_DIR=`dirname $0`

if [ ! -z "SCRIPTS_DIR" ]
then
    SCRIPTS_DIR="${SCRIPTS_DIR}/"
fi

MK_TT="${SCRIPTS_DIR}mk-sched-table.py"
MK_OE="${SCRIPTS_DIR}mk-oe-tables.py"
MK_TS="${SCRIPTS_DIR}mk-tasks-table.py"

EXP_FOLDER=$(basename `dirname $DIR`)
EXP_ID=`basename $DIR`

echo "Experiment: $DIR"
echo "Scheduler:  WANT_SCHED_${S}"
$MK_TS $DIR || exit 2
$MK_OE $DIR || exit 3
$MK_TT $DIR || exit 4
cat > gentab_exp.h <<END_OF_CONF
#define EXP_NAME "${EXP_FOLDER}/${EXP_ID}"
#define EXP_DATA_FILE "RESULTS/${EXP_FOLDER}/${EXP_ID}/" SCHEDULER_KEY ".csv"
#define EXP_ID ${EXP_ID}
#define WANT_SCHED_${S}
END_OF_CONF
cat gentab_exp.h
