#!/usr/bin/env python3

import sys
import os
import math

MAX_TASKS = 16

MAX_TABLE_LENGTH = (2**15 - 1) // 4

f = open("gentab_tt.h", "w")

print("""
/* NOTE: This file is automatically generated and should be included
 * only from sched_table.cpp. */

static PROGMEM const struct table_entry the_table[] = {""", file=f)

slots = 0
for line in open(sys.argv[1] + '/tt.txt').readlines():
    slot = [int(x) for x in line.strip().split(" ")]
    print("\t{{ {0:>2d}, {1:>7d}UL }},".format(min(MAX_TASKS, slot[0]), slot[1]),
        file=f)
    slots += 1
    if slots == MAX_TABLE_LENGTH:
        print("WARNING: table too long!")
        break

print("};", file=f)

print("""
#define table_length {0}U
""".format(slots), file=f)

f.close()
